abuild.in 36.8 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
FAKEROOT=${FAKEROOT:-"fakeroot"}
22 23 24 25 26

: ${APK:=abuild-apk}
: ${ADDUSER:=abuild-adduser}
: ${ADDGROUP:=abuild-addgroup}

27
apk_opt_wait="--wait 30"
28

Natanael Copa's avatar
Natanael Copa committed
29
# read config
Natanael Copa's avatar
Natanael Copa committed
30
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
31 32
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

33
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
34 35 36 37 38 39
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
40 41 42 43 44 45 46 47 48 49 50 51 52 53
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
54 55 56 57 58
fi	
	

# functions
msg() {
59
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
60 61 62
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
63 64 65 66 67 68 69
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

msg2() {
	[ -n "$quiet" ] && return 0
	#      ">>> %s"
	printf "    %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
70 71 72 73 74 75
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
76 77 78 79 80 81
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

warning2() {
	#      ">>> WARNING: 
	printf "             %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
82 83 84 85 86 87
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
88 89 90 91 92 93
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

error2() {
	#      ">>> ERROR: 
	printf "           %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
94
}
95

Linux User's avatar
Linux User committed
96
set_xterm_title() {
97
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
98
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
99 100 101 102 103
	fi
} 

cleanup() {
	set_xterm_title ""
104
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
105
		msg "Uninstalling dependencies..."
106
		$APK del --quiet $apk_opt_wait $uninstall_after
107
	fi
108 109 110
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
Linux User's avatar
Linux User committed
111 112
}

Natanael Copa's avatar
Natanael Copa committed
113
die() {
Linux User's avatar
Linux User committed
114
	error "$@"
Linux User's avatar
Linux User committed
115
	cleanup
Natanael Copa's avatar
Natanael Copa committed
116 117 118
	exit 1
}

119
# check if apkbuild is basicly sane
120
default_sanitycheck() {
121
	local i= j= suggestion=
122
	msg "Checking sanity of $APKBUILD..."
123 124 125
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
126
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
127
		$APK version --check -q "$pkgver" ||\
128 129
			die "$pkgver is not a valid version"
	fi
130
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
131 132 133 134
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

135 136 137 138 139 140 141
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

142 143 144 145 146 147 148 149 150 151
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
152
	for i in $install; do
153
		local n=${i%.*}
154
		local suff=${i##*.}
155 156 157 158 159
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
160
			die "$i: install script does not match pkgname or any subpackage"
161
		fi
162
		[ -e "$startdir/$i" ] || die "install script $i is missing"
163 164 165 166 167 168
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
169 170
	done
	
171 172 173 174 175 176 177 178
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
		[ "$f" = "$i" ] && die "$f: triggers must contain '='" 
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
179

180 181
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
182 183
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
184 185 186 187
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
188
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
189
			case "$i" in
190
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
191
			esac
192 193
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
194

195 196
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
197
			source_has $i || die "$i exists in md5sums but is missing in source"
198 199
		done
	fi
200

201 202 203
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
204 205

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
206 207

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
208 209 210
	return 0
}

211 212 213 214
sanitycheck() {
	default_sanitycheck
}

215
md5check() {
216
	local dummy f endreturnval originalparams origin file
217 218 219
	if [ -z "$source" ]; then
		return 0
	fi
220
	if [ -z "$md5sums" ]; then
221
		die "Use 'abuild checksum' to generate/update the checksum(s)"
222
	fi
223 224 225
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
226
	fetch || return 1
227
	msg "Checking md5sums..."
Natanael Copa's avatar
Natanael Copa committed
228
	cd "$srcdir" || return 1
229 230 231 232 233 234 235 236
	IFS=$'\n'
	endreturnval=0
	originalparams=$@
	set -- $source
	for src in $md5sums; do
		origin=$1; shift
		echo "$src" | md5sum -c
		if [ $? -ne 0 ]; then
237
			endreturnval=1
238 239 240 241 242 243 244 245 246 247 248
			is_remote $origin || continue
			echo "Because the remote file above failed the md5sum check it will be deleted."
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	set -- $originalparams
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
249 250
}

251 252
# verify upstream sources
sourcecheck() {
253 254 255 256 257 258 259 260 261 262
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
		esac
		wget -q -s "$uri" || return 1
263
	done
264
	return 0
265
}
266

267 268 269
# convert curl options to wget options and call wget instead of curl
wget_fallback() {
	local wget_opts= outfile= opt=
270
	while getopts "C:Lko:s" opt; do
271
		case $opt in
272
		'L') ;; # --location. wget does this by default
273
		'f') ;; # --fail. wget does this by default
274 275 276 277 278 279 280 281 282 283
		'C') wget_opts="$wget_opts -c";; # --continue-at
		's') wget_opts="$wget_opts -q";; # --silent
		'o') wget_opts="$wget_opts -O $OPTARG";; # --output
		'k') wget_opts="$wget_opts --no-check-certificate";; #gnu wget
		esac
	done
	shift $(( $OPTIND - 1 ))
	wget $wget_opts "$1"
}

Natanael Copa's avatar
Natanael Copa committed
284 285
uri_fetch() {
	local uri="$1"
286
	local d="${uri##*/}"	# $(basename $uri)
287
	local opts
288
	[ -n "$quiet" ] && opts="-s"
289 290

	local lockfile="$SRCDEST/$d".lock
291

292 293 294 295 296
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
297
	esac
298 299

	case "$uri" in
300
		https://*) opts="-k";;
301
	esac
302

Natanael Copa's avatar
Natanael Copa committed
303
	mkdir -p "$SRCDEST"
304 305 306 307

	CLEANUP_FILES="$CLEANUP_FILES $lockfile"
	(
	flock -n -x 200 || msg "Waiting for ${lockfile##*/}..."
308
	flock -x 200
309 310 311

	[ -f "$SRCDEST/$d" ] && exit 0 # use exit since its a subshell

312 313
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
314
		opts="$opts -C -"
Natanael Copa's avatar
Natanael Copa committed
315
	fi
Linux User's avatar
Linux User committed
316
	msg "Fetching $uri"
317 318

	# fallback to wget if curl is missing. useful for bootstrapping
319
	local fetcher=
320 321
	if ! [ -x "$(which curl)" ]; then
		fetcher=wget_fallback
322 323
	else
		fetcher=curl
324
		opts="$opts -L -f"
325 326 327
	fi

	$fetcher $opts -o "$SRCDEST/$d.part" "$uri" \
328
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
329 330 331 332 333 334

	) 200>$lockfile

	local rc=$?
	rm -f "$lockfile"
	return $rc
Natanael Copa's avatar
Natanael Copa committed
335 336
}

337 338
is_remote() {
	case "$1" in
339
		http://*|ftp://*|https://*|saveas-*://*)
340 341 342 343 344
			return 0;;
	esac
	return 1
}

345 346 347 348 349
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
350 351 352 353 354
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
355 356 357 358
	fi
	uri_fetch "$uri"
}

359
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
360 361
	local s
	mkdir -p "$srcdir"
362 363
	for s in $source; do
		if is_remote "$s"; then
364
			uri_fetch_mirror "$s" || return 1
365 366 367 368
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
369 370 371
	done
}

372 373 374 375
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
376 377 378 379 380 381 382 383 384 385 386 387 388 389 390
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
391
# unpack the sources
392
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
393
	local u
394 395
	if [ -z "$force" ]; then
		md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
396
		initdcheck || return 1
397
	fi
Natanael Copa's avatar
Natanael Copa committed
398 399 400 401
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
402
			*.tar.gz|*.tgz)
403
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
404 405
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
406
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
407
				tar -C "$srcdir" -jxf "$s" || return 1;;
408 409 410 411
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
412 413 414
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
415 416 417
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
418 419 420 421
		esac
	done
}

422 423 424 425
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
426 427
# cleanup source and package dir
clean() {
428
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
429
	rm -rf "$srcdir"
430
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
431 432 433 434 435 436
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
437 438 439 440
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
441 442 443
	done
}

444 445 446 447 448 449 450 451 452 453
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
454 455
cleanpkg() {
	local i
456
	getpkgver || return 1
457
	msg "Cleaning built packages..."
458
	for i in $(listpkgnames); do
459 460
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
461
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
462
	done
463
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
464 465
}

466 467 468
# clean all packages except current
cleanoldpkg() {
	local i j
469
	getpkgver || return 1
470
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
471
	for i in $(listpkgnames); do
472 473 474 475 476
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
477 478 479 480
		done
	done
	return 0
}
481 482 483 484 485

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
486
			local gopt=
487
			msg "Creating user $i"
488 489 490
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
491
			$ADDUSER -S -D -H $gopt $i || return 1
492 493 494 495 496
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
497
			$ADDGROUP -S $i || return 1
498 499 500 501 502
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
503 504
runpart() {
	local part=$1
505
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
506 507 508 509
	$part || die "$part failed"
}

# override those in your build script
510 511 512 513 514 515 516 517
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
518 519 520 521
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
522
build() {
523
	:
Natanael Copa's avatar
Natanael Copa committed
524 525
}

526 527 528
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
529
	mkdir -p "$PKGDEST"
530 531 532
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

533 534 535 536 537 538 539 540 541
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
	# look for *.la files
	i=$(find "$dir" -name '*.la' | sed "s|^$dir|\t|")
	if [ -n "$i" ] && ! options_has "libtool"; then
		error "Libtool archives (*.la) files found and \$options has no 'libtool' flag:"
		echo "$i"
		return 1
	fi
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
558 559 560 561 562 563 564 565 566
	# check so we dont have any suid root binaries that are not 
	i=$(find "$dir" -type f -perm +6000 \
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
567 568 569
	return 0
}

570
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
571 572
	local i
	cd "$startdir"
573
	for i in $subpackages; do
574 575
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
576
		msg "Running split function $func..."
577 578
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
		subpkgdir="$dir" subpkgname="$name" \
579
			$0 $func prepare_package || return 1
580
		postcheck "$dir" "$name" || return 1
Natanael Copa's avatar
Natanael Copa committed
581
	done
582
	postcheck "$pkgdir" "$pkgname" || return 1
583 584
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
585
		warning "Found /usr/share/locale"
586
		warning2 "Maybe add \$pkgname-lang to subpackages?"
587
	fi
Natanael Copa's avatar
Natanael Copa committed
588 589
}

590
default_lang() {
591
	pkgdesc="Languages for package $pkgname"
592 593 594 595 596 597 598 599 600 601 602 603 604
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

605
default_lang_subpkg() {
606 607 608 609
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
610
	pkgdesc="$pkgname language pack for $lang"
611 612
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
613 614 615 616 617
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
618
		|| return 1
619 620 621 622 623
	done
}

lang_subpkg() {
	default_lang_subpkg
624 625 626 627 628 629 630 631 632 633 634
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

635 636 637 638 639 640 641 642 643 644 645 646
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

647 648 649 650 651 652
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

653
prepare_metafiles() {
654
	getpkgver || return 1
655 656
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
657
	local dir=${subpkgdir:-$pkgdir}
658
	local pkg="$name-$pkgver-r$pkgrel.apk"
659
	local pkginfo="$controldir"/.PKGINFO
660
	local sub
Natanael Copa's avatar
Natanael Copa committed
661 662 663
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
664
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
665 666
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
667
	local parch="$CARCH"
668 669 670 671 672

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
673

674
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
675
	if [ -n "$FAKEROOTKEY" ]; then
676
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
677
	fi
678 679
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
680
pkgname = $name
681
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
682 683 684 685 686
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
687
arch = $parch
688
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
689
EOF
690 691
	local i deps
	deps="$depends"
692
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
693 694
		for i in $install $triggers; do
			local s=${i%=*}
695
			[ "$name" != "${s%.*}" ] && continue
696
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
697 698 699 700 701
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
702 703
	fi
	
704 705 706 707 708 709 710 711 712 713
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

Natanael Copa's avatar
Natanael Copa committed
714
	for i in $license; do
715
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
716 717
	done
	for i in $replaces; do
718
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
719
	done
720
	for i in $deps; do
721
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
722 723
	done
	for i in $conflicts; do
724
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
725 726
	done
	for i in $provides; do
727
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
728
	done
729 730 731 732 733 734
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
735 736 737
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
738 739

	local metafiles=".PKGINFO"
740 741 742
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
743
		if [ "$n" != "$name" ]; then
744 745
			continue
		fi
746
		script=${f#$name}
747
		msg "Adding $script"
748
		cp "$startdir/$f" "$controldir/$script" || return 1
749
		chmod +x "$controldir/$script"
750 751
		metafiles="$metafiles $script"
	done
752
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
753
}
754

755 756
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
757
	[ "$arch" = "noarch" ] && return 0
758
	options_has "!tracedeps" && return 0
759
	# lets tell all the .so files this package provides in .provides-so
760 761
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
762 763 764 765 766
	# lets tell all the places we should look for .so files - all rpaths
	scanelf -q -Rr "$dir" | sed -e 's/[[:space:]].*//' -e 's/:/\n/' \
		| sort | uniq \
		>"$controldir"/.rpaths
	# now find the so dependencies
767
	scanelf -Rn "$dir" | tr ' ' ':' | awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
768 769 770
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
771 772
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
773
	done
Natanael Copa's avatar
Natanael Copa committed
774 775
}

776 777 778 779 780 781 782 783 784 785 786 787
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

788 789 790 791 792
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

793 794 795 796 797 798 799
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
800 801 802
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
803 804 805 806
	fi
	return 0
}

807
prepare_package() {
808
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
809
	stripbin
810 811
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
812 813 814 815 816 817 818 819
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

820 821 822 823 824 825 826 827 828 829 830 831 832 833 834 835 836 837 838 839 840 841 842
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

843 844 845
trace_apk_deps() {
	local name="$1"
	local dir="$2"
846
	local i= j= found= autodeps= deppkgs= missing= so_paths= self_provided=
847
	msg "Tracing dependencies for $name..."
848 849 850
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
851
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
852 853 854 855
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
856
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
857 858
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
859
		msg "  added libgcc (due to libpthread)"
860
	fi
861
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
862
		found=
863
		# first check if its provide by same apkbuild
864
		for j in "$dir"/../.control.*/.provides-so; do
865
			grep -w "$i" "$j" >/dev/null || continue
866
			found=${j%/.provides-so}
867
			found=${found##*/.control.}
868
			break
869
		done
870 871 872 873 874 875
		if [ -n "$found" ]; then
			if ! list_has "$found" $self_provided; then
				self_provided="$self_provided $found"
			fi
		else
			missing="$missing $i"
876
		fi
877 878 879
	done

	# find all packages that holds the so files
880 881 882 883 884
	if [ -f "$dir"/.rpaths ]; then
		so_files=$(find_so_files "$dir"/.rpaths $missing) || return 1
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

885
	for found in $self_provided $deppkgs; do
886
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
887 888 889
			warning "You can remove '$found' from depends"
			continue
		fi
890 891
		if [ "$found" != "$name" ] && ! list_has "$found" $autodeps; then
			autodeps="$autodeps $found"
892
			msg "  added $found"
893
		fi
894
	done
895

896 897 898 899 900 901 902
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

903 904
create_apks() {
	local file
905
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
906
	mkdir -p "$PKGDEST"
907
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
908 909 910
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
911
		local apk=$name-$ver.apk
912
		local datadir="$pkgbasedir"/$name
913 914

		trace_apk_deps "$name" "$dir" || return 1
915
		msg "Creating $apk..."
916
		(
917 918
		cd "$datadir"
		# data.tar.gz
919 920 921 922 923 924
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
925 926 927 928 929 930

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
931
		cd "$dir"
932 933
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
934
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
935

936 937 938
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
939 940 941
	done
}

942
clean_abuildrepo() {
943
	local apk
944 945 946
	cd "$abuildrepo" || return 1
	
	# remove compat symlink
947
	for d in "$abuildrepo/$CARCH"; do
948 949
		[ -L "$d" ] && rm "$d"
	done
950

951 952
	# remove broken links from abuildrepo
	for apk in *.apk */*.apk; do
953 954 955 956
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done
957
}
958

959
mklinks_abuildrepo() {
960 961
	local apk
	mkdir -p "$abuildrepo"/$CARCH
962
	cd "$abuildrepo" || return 1
963
	# create links for this package
964
	for apk in $(listpkg); do
965
		[ -f "$PKGDEST"/$apk ] || continue
966
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$CARCH/$apk
967
	done
968 969 970 971 972 973 974 975 976 977 978 979 980 981
}

update_abuildrepo() {
	local d apk
	if ! apk_up2date || [ -n "$force" ]; then
		sanitycheck && builddeps && clean && fetch && unpack \
			&& prepare && mkusers && rootpkg || return 1
	fi

	clean_abuildrepo
	mklinks_abuildrepo

	cd "$abuildrepo"
	local index=$CARCH/APKINDEX.tar.gz
982

983
	msg "Updating the cached abuild repository index..."
984 985
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
986 987
	if [ -f "$index" ]; then
		oldindex="--index $index"
988
	fi
989
	$APK index --quiet $oldindex --output "$index".unsigned \
990
		--description "$repo $(cd $startdir && git describe)" \
991 992
		--rewrite-arch $CARCH \
		$CARCH/*.apk || exit 1
993
	msg "Signing the index..."
994 995 996
	abuild-sign -q "$index".unsigned || exit 1
	mv "$index".unsigned "$index"
	chmod 644 "$index"
997 998
}

999
# predefined splitfunc doc
1000
default_doc() {
1001
	depends="$depends_doc"
1002
	pkgdesc="$pkgdesc (documentation)"
1003
	arch=${arch_doc:-"noarch"}
1004

Natanael Copa's avatar
Natanael Copa committed
1005
	local i
1006
	for i in doc man info html sgml licenses gtk-doc; do
1007 1008 1009
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
1010 1011
		fi
	done
1012 1013 1014
	
	rm -f "$subpkgdir/usr/share/info/dir"

1015 1016 1017
	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
1018 1019 1020
	return 0
}

1021 1022 1023 1024
doc() {
	default_doc
}

1025
# predefined splitfunc mod
1026
default_mod() {
1027
	depends="$kernel $depends_mod"
Natanael Copa's avatar
Natanael Copa committed
1028
	for i in firmware modules; do
1029 1030 1031
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
1032
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
1033 1034 1035 1036
		fi
	done
}

1037 1038 1039 1040
mod() {
	default_mod
}

1041
# predefined splitfunc dev
1042
default_dev() {
1043
	local i= j=
1044
	depends="$pkgname $depends_dev"
1045 1046
	pkgdesc="$pkgdesc (development files)"

1047 1048 1049 1050
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
1051
	cd "$pkgdir" || return 0
1052 1053
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
1054
			usr/share/vala/vapi usr/share/gir-[0-9]*\
1055
			$(find -name include -type d) 		\
1056
			$(find usr/ -name '*.[acho]' 2>/dev/null); do
1057 1058
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
1059
			mkdir -p "$d"
1060
			mv "$pkgdir/$i" "$d"
1061
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
1062 1063
		fi
	done
1064 1065 1066 1067 1068 1069 1070
	# move *.so links needed when linking the apps to -dev packages
	for i in lib/*.so usr/lib/*.so; do
		if [ -L "$i" ]; then
			mkdir -p "$subpkgdir"/"${i%/*}"
			mv "$i" "$subpkgdir/$i" || return 1
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
1071
	return 0
Natanael Copa's avatar
Natanael Copa committed
1072 1073
}

1074 1075 1076 1077
dev() {
	default_dev
}

1078 1079 1080 1081
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

1082 1083 1084 1085 1086 1087 1088 1089
do_fakeroot() {
	if [ -n "$FAKEROOT" ]; then
		$FAKEROOT -- "$@"
	else
		"$@"
	fi
}

Natanael Copa's avatar
Natanael Copa committed
1090 1091
# build and package in fakeroot
rootpkg() {
1092 1093 1094 1095
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
1096
		do_build=package
1097
	fi
Natanael Copa's avatar
Natanael Copa committed
1098
	cd "$startdir"
1099
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
1100
	do_fakeroot "$abuild_path" $color_opt $do_build \
1101
		prepare_subpackages \
1102
		prepare_language_packs \
1103
		prepare_package \
1104
		create_apks
Natanael Copa's avatar
Natanael Copa committed
1105 1106 1107
}

srcpkg() {
1108
	getpkgver || return 1
1109
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
1110
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
1111 1112 1113 1114 1115
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
1116
	msg "Creating source package $p.src.tar.gz..."
1117
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
1118 1119
}

Natanael Copa's avatar
Natanael Copa committed
1120 1121
# return true if arch is supported or noarch
check_arch() {
Natanael Copa's avatar
Natanael Copa committed
1122
	list_has $CARCH $arch || [ "$arch" = "noarch" ] || [ "$arch" = "all" ]
Natanael Copa's avatar
Natanael Copa committed
1123 1124
}

1125
# check if package is up to date
1126
apk_up2date() {
1127
	getpkgver || return 1
1128
	local pkg="$PKGDEST/$pkgname-$pkgver-r